unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, OleCtrls, SHDocVw,MSHTML_TLB,ComObj, Buttons;

type
  TForm1 = class(TForm,IElementBehaviorFactory)
    Browser: TWebBrowser;
    Panel1: TPanel;
    Edit1: TEdit;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure BrowserDocumentComplete(Sender: TObject;
      const pDisp: IDispatch; var URL: OleVariant);
  private
  protected
    function FindBehavior(const bstrBehavior: WideString; const bstrBehaviorUrl: WideString;
                          const pSite: IElementBehaviorSite; out ppBehavior: IElementBehavior): HResult; stdcall;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses uImageBehavior;


{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  Browser.Navigate(Edit1.Text);
end;

procedure TForm1.BrowserDocumentComplete(Sender: TObject;
  const pDisp: IDispatch; var URL: OleVariant);
var
  Imgs : IHTMLElementCollection;
  I : Integer;
  Element : IHTMLElement2;
  Factory : OLEVariant;
begin
  Factory := Self as IElementBehaviorFactory;
  Imgs := (Browser.Document as IHTMLDocument2).all.tags('img') as IHTMLElementCollection;
  for I := 0 to Imgs.length -1 do
  begin
    if Supports(Imgs.item(I,0),IHTMLElement2,Element) then
      Element.addBehavior('',Factory);
  end;
end;

function TForm1.FindBehavior(const bstrBehavior,
  bstrBehaviorUrl: WideString; const pSite: IElementBehaviorSite;
  out ppBehavior: IElementBehavior): HResult;
var
  Element : IHTMLElement;
begin
  Result := E_NOTIMPL;
  OleCheck(pSite.GetElement(Element));
  if Supports(Element,IHTMLImgElement) then
  begin
    ppBehavior := TImageBehavior.Create as IElementBehavior;
    Result := S_OK;
  end;
end;

end.
